set echo on
clear screen
create table myemp (empno,ename,sal)
as
select emp.empno + l * 10000
     , emp.ename
     , emp.sal
  from emp
     , ( select level-1 l from dual connect by level <= 50000 )
/
exec dbms_stats.gather_table_stats(user,'myemp')
select avg(sal)
  from myemp
/
pause
/*
select *
  from v$session_longops
 where opname = 'Salarisverhoging'
/
select sofar
     , totalwork
     , time_remaining
     , elapsed_seconds
  from v$session_longops
 where opname = 'Salarisverhoging'
/
*/
pause
declare
  rindex    binary_integer;
  slno      binary_integer;
begin
  rindex := dbms_application_info.set_session_longops_nohint;  --  -1
  for r in
  ( select rowid rid
         , rownum teller
         , count(*) over () aantal
      from myemp
           for update of sal
  )
  loop
    dbms_application_info.set_session_longops
    ( rindex      => rindex
    , slno        => slno
    , op_name     => 'Salarisverhoging'
    , target      => null
    , context     => 0
    , sofar       => r.teller
    , totalwork   => r.aantal
    , target_desc => 'Verhoging met 5%'
    , units       => 'Werknemers'
    );
    update myemp
       set sal = sal * 1.05
     where rowid = r.rid
    ; 
  end loop;
end;
/
select avg(sal)
  from myemp
/
set echo off
drop table myemp purge
/
