column time_ago format a20
column text format a80
set linesize 135
set echo on
clear screen
select rpad(object_type,30) || ' ' || object_name
  from all_objects
 where owner = 'LOGGER'
 order by object_type
     , object_name
/
pause
create package mypkg
as
  procedure p1;
  procedure p2;
  procedure p3;
  procedure p;
end mypkg;
/
pause
clear screen
create package body mypkg
as
  procedure p1
  is
  begin
    logger.log('Start','mypkg.p1');
    dbms_output.put_line('p1');
    logger.log('Eind','mypkg.p1');
  end p1
  ;
  procedure p2
  is
  begin
    logger.log('Start','mypkg.p2');
    dbms_output.put_line(case when 1/0 = 0 then 'p2' end);
    logger.log('Eind','mypkg.p2');
  end p2
  ;
  procedure p3
  is
  begin
    logger.log('Start','mypkg.p3');
    dbms_output.put_line('p3');
    logger.log('Eind','mypkg.p3');
  end p3
  ;
  procedure p
  is
  begin
    p1;
    p2;
    p3;
  exception
  when others then
    logger.log_error();
    raise;
  end p
  ;
end mypkg;
/
pause
clear screen
exec mypkg.p
pause
clear screen
select * from logger_logs_5_min
/
pause
clear screen
select * from logger_logs_5_min where logger_level = 2
/
pause
clear screen
select * from logger_logs_terse
/
pause
drop package mypkg
/
exec logger.purge_all
